///////////////////////////////////////////////////////////
////// GibPascal pascal.c
////// Released under the GPLv3
////// Written by:
//////    Michael Gibson
//////    (c)2003-2021
///////////////////////////////////////////////////////////
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <process.h>
#include "pascal_variable.h"
#include "pascal_main.h"
#include "pascal_path.h"
#include "pascal_file.h"

int main(int argc, char *argv[])
{ 
  char filename[256],systemvar1[30],systemvar2[100],systemvar3[200];
  char teststr[256];
  char temps[35];                                               // stores numbers for string editing 
  char temps2[35];                                              // stores numbers for string editing
  char options[5];
  int  int_value;
  int  xxx;
  float tempi;                                                  // default temp number store (was int)
  int debug=0;

  int jloop=0;                                                  // white space in numbers
  int kloop=0;                                                  // white space in numbers
  int wscount=0;                                                // whitespace in numbers
  int x=0;                                                      // used as loop var in while
  int y=0;                                                      // while loop var match

  int while_l_cmd_found=0;                                      // while-less-than found
  int while_l_cmd_max;                                          // number we need to reach
  int while_l_cmd_sat=0;                                        // while-less-than satisfied
  int while_l_cmd_typ=0;                                        // 0 = '<', 1 = '<='

  int while_m_cmd_found=0;                                      // while-more-than found
  int while_m_cmd_max;
  int while_m_cmd_sat=0;                                        // while-more-than satisfied
  int while_m_cmd_typ=0;                                        // 0 = '>', 1 = '>='

  int while_c_cmd_found=0;                                      // while-count-found
  int while_c_cmd_max;                                          // number we need to reach
  int while_c_cmd_times=0;
  int while_c_cmd_sat=0;

  char while_trash[64];                                         // disregarded text from while
  char while_do_num_s[12];                                      // while number in string form
  int  while_do_num_i;                                          // while number in integer form

  int loop=0, loop2=0, loop3=0, loop4=0;                        // different variables used in different loops

  char have_begin  ='F';                                        //master begin so we know paramater section done
  char have_program='F';
  char have_end    ='F';                                        //master program end 

  int num_of_space=0;
  char space_check;

                                                                // flush memory for variables
  for(xxx=0;xxx<=230;xxx++){
    strcpy(value_of_variables[xxx],"\0\0\0\0\0\0\0\0\0\0\0");
  }
  strcpy(temps,"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0");

  if (strncmp(argv[0],"./gpdebug",7)==0 || strncmp(argv[0],"gpdebug",5)==0) debug=1;

  sprintf(filename,"%s",argv[1]);                               // find the script name
  sprintf(options,"%s",argv[2]);                                // find additional paramters

  if(filename[1]=='v'){
    printf("version = %s\n",version);                           // if -v is used, print version 
    exit(0);
  }

  if(filename[1]=='m'){
    printf("Remember, we belong to God. version = %s\n",version);                           // if -v is used, print version 
    exit(0);
  }


  if((fp=fopen(filename,"r"))==NULL){                           // open the script file to read
     printf("GibPascal:Sorry no file or flag specified\n");
     exit(0);
  }

  if(options[1]=='d') debug=1;

  //special variables structures


  strcpy(variable_names[249],"SYSTEM.cwd");
  variable_type[249]='s';

  strcpy(variable_names[250],"XVALUE.return");
  variable_type[250]='i';

  strcpy(variable_names[251],"PI");
  variable_type[251]='r';
  strcpy(value_of_variables[251],"3.14159265");

  strcpy(variable_names[253],"SYSTEM.os");
  variable_type[253]='s';

  strcpy(variable_names[254],"SYSTEM.info");
  variable_type[254]='s';

  strcpy(variable_names[255],"GetCurrentDir");
  variable_type[255]='s';

  get_system(&systemvar1,&systemvar2);
  strcpy(value_of_variables[253],systemvar1);
  strcpy(value_of_variables[254],systemvar2);
  

  do{
    num_of_space=0;
    fgets(stread,256,fp);                                       // read in a line of code 
  

    do{
      space_check=stread[num_of_space];                         // look for how many spaces before command or statement. 
      num_of_space++;
    }while(space_check==' ' ||space_check=='\t');
    num_of_space--;

    syn_chk(stread);                                            // check syntax
                                                        
    if(strstr(stread,"program")!= '\0' && strstr(stread,";") != '\0') have_program='T';
    if(strstr(stread,"begin")!= '\0') have_begin='T';           // begin starts statement block and ends paramater block
    if(strstr(stread,"end.") != '\0') have_end='T';             // end. states the end of programm

    if(strstr(stread,"GetCurrentDir")             !='\0'){      // special variable 'GetCurrentDir'
      strcpy(systemvar3,get_dir(debug));                        // load into variable
      strcpy(value_of_variables[255],systemvar3);
      if(debug==1)printf("**[Main] fun system return '%s' \n",systemvar3);
      if(debug==1)printf("**[Main] var system return '%s' \n",value_of_variables[255]);
    }


    if(strstr(stread,"SYSTEM.cwd")             !='\0'){
      strcpy(systemvar3,get_dir(debug));
      strcpy(value_of_variables[249],systemvar3);
      if(debug==1)printf("**[Main] fun system return '%s' \n",systemvar3);
      if(debug==1)printf("**[Main] var system return '%s' \n",value_of_variables[255]);
    }

    if(strstr(stread,"(*")                            !='\0') goto DoNothing;
    if(strstr(stread,"//")                            !='\0') goto DoNothing;
    if(strcasestr(stread,"  wround(")                 !='\0') pascal_wround(num_of_space+7,debug);
    if(strcasestr(stread,"  wsqrt(")                  !='\0') pascal_wsqrt(num_of_space+6,debug);
    if(strcasestr(stread,"  write(")                  !='\0') pascal_writeln(num_of_space+6,debug);
    if(strcasestr(stread,"  append(")                 !='\0') pascal_rewrite(num_of_space+7);
    if(strcasestr(stread,"  rewrite(")                !='\0') pascal_rewrite(num_of_space+8);
    if(strcasestr(stread,"  findrp(")                 !='\0') g_pascal_findrp(num_of_space+7,debug);
    if(strcasestr(stread,"  findow(")                 !='\0') g_pascal_findow(num_of_space+7,debug);
    if(strcasestr(stread,"  insert(")                 !='\0') pascal_insert(num_of_space+7,debug);
    if(strcasestr(stread,"  delete(")                 !='\0') pascal_delete(stread,num_of_space+7,debug);
    if(strcasestr(stread,"  writeln(")                !='\0') { pascal_writeln(num_of_space+8,debug);printf("\n");} // add that return to writeln ;)
    if(strcasestr(stread,"  writewc(")                !='\0') g_pascal_writewc(num_of_space+8,debug);
    if(strcasestr(stread,"  read(")                   !='\0') pascal_read(num_of_space+5,debug);
    if(strcasestr(stread,"  readln(")                 !='\0') pascal_read(num_of_space+7,debug);
    if(strcasestr(stread,"  query_remote_web_client(")!='\0') query_remote_web_client();
    if(strcasestr(stread,"  read_version(")           !='\0') g_pascal_read_version(num_of_space+13);
    if(strcasestr(stread,"  read_http_user_agent(")   !='\0') read_http_user_agent(stread,num_of_space+21);
    if(strcasestr(stread,"  read_query_string(")      !='\0') read_query_string(stread,num_of_space+18);
    if(strcasestr(stread,"  read_remote_addr(")       !='\0') read_remote_addr(stread,num_of_space+17);
    if(strcasestr(stread,"  read_date(")              !='\0') g_pascal_read_date(num_of_space+10);
    if(strcasestr(stread,"  read_content_length(")    !='\0') read_content_length(stread,num_of_space+20); 
    if(strcasestr(stread,"  halt;")                   !='\0') pascal_halt(stread);
    if(strcasestr(stread,"  halt(")                   !='\0') pascal_halt(stread);   
    if(strcasestr(stread,"  writewh(")                !='\0') g_pascal_writewh();
    if(strcasestr(stread,"  closefile(")              !='\0') g_pascal_closefile();
    if(strcasestr(stread,"  system('")                !='\0') g_pascal_system(stread,debug);
    if(strcasestr(stread,"  exec('")                  !='\0') g_pascal_system(stread,debug);    
    if(strcasestr(stread,"  delay(")                  !='\0') pascal_delay(stread,debug);

    // X11 functionailty possibly removed in GPascal 2
    // unrem for Linux
    //if(strstr(stread,"  x_msgbox(")             !='\0') x_msgbox(stread);
    //if(strstr(stread,"  x_imgbox(")             !='\0') x_imgbox(stread);
    //if(strstr(stread,"  x_radiobox(")           !='\0') {x_radiobox(stread);sprintf(value_of_variables[250],"%d",X11return);}
    //if(strstr(stread,"  x_open(")               !='\0') x_open();
    //if(strstr(stread,"  x_close(")              !='\0') x_close();
    if(strstr(stread,"const") !='\0' && have_begin != 'T') pascal_var(debug,1);
    if(strstr(stread,"var ")  !='\0' && have_begin != 'T') pascal_var(debug,0);
    if(strstr(stread,"   ")   !='\0' && 
                   have_begin != 'T' && 
                   strstr(stread,":") !='\0' &&
                   block_type==1) pascal_var(debug,0);
    if(strstr(stread,"   ")   !='\0' && 
                   have_begin != 'T' && 
                   strstr(stread,"=") !='\0' &&
                   block_type==2) pascal_var(debug,1);
    if(strstr(stread,"   ")   !='\0' &&
                    have_begin != 'T' &&
                    block_type==3) pascal_label(debug);
    if(strstr(stread,"label ")!='\0' && have_begin != 'T') pascal_label(debug);
    if(strstr(stread,"  repeat")!='\0') {
       fflush(fp);
       whereinfile = ftell(fp);
       if(debug==1)printf("**[repeat] file pointer=%ld\n",whereinfile);
       repeat_cmd_found=1;
    } 

//////////////  while less
//////////////  while type 1.0 and 1.1 
    if(strstr(stread,"  while ") !='\0' && strstr(stread," <") !='\0' && strstr(stread,"do") !='\0') {
       x=0;
       y=0;
       while_l_cmd_sat=0;
     //// find variable that matches ////
      for(y=0;y<=256;y++){
          if(strstr(stread,variable_names[y]) != '\0') break; 
      }

      if(debug==1)printf("**[while] var name '%s' \n",variable_names[y]);
      if(debug==1)printf("**[while] value of var '%s' \n",value_of_variables[y]);

       if(debug==1)printf("**[while less] while less loop found! \n");
       do{
          while_trash[x]=stread[x];
          x++;
       }while(stread[x-2] != '<');                              // keep reading till we get to '<'

       if(stread[x-1]=='='){
           while_l_cmd_typ = 1;                                 // if '<='
           x++;
       }
       else while_l_cmd_typ = 0;                                // else just '<'

       if(stread[x-1]==' ') sprintf(while_do_num_s,"%c%c%c",stread[x],stread[x+1],stread[x+2]);
       if(stread[x-1]!=' ') sprintf(while_do_num_s,"%c%c%c",stread[x-1],stread[x],stread[x+1]);
       if(debug==1)printf("**[while loop (less)] value ='%s' found!\n",while_do_num_s);
       while_l_cmd_max = atoi(while_do_num_s);

       if(while_l_cmd_found==0){
         fflush(fp);
         whereinfileWL1 = ftell(fp);
         if(debug==1)printf("**[while loop] file pointer=%ld\n",whereinfileWL1);
         while_l_cmd_found=1;
       }
    } 


//////////////  while more
    if(strstr(stread,"  while ") !='\0' && strstr(stread," >") !='\0' && strstr(stread,"do") !='\0') {
       x=0;
       y=0;
       while_m_cmd_sat=0;
     //// find variable that matches ////
      for(y=0;y<=256;y++){
          if(strstr(stread,variable_names[y]) != '\0') break; 
      }

      if(debug==1)printf("**[while loop] var name '%s' \n",variable_names[y]);
      if(debug==1)printf("**[while loop] value of var '%s' \n",value_of_variables[y]);

       if(debug==1)printf("**[while less] while less loop found! \n");
       do{
          while_trash[x]=stread[x];
          x++;
       }while(stread[x-2] != '>'); 


       if(stread[x-1]=='='){
           while_m_cmd_typ = 1;                                 // if '>='
           x++;
       }
       else while_m_cmd_typ = 0;                                // else just '>'



       if(stread[x-1]==' ') sprintf(while_do_num_s,"%c%c%c",stread[x],stread[x+1],stread[x+2]);
       if(stread[x-1]!=' ') sprintf(while_do_num_s,"%c%c%c",stread[x-1],stread[x],stread[x+1]);
       if(debug==1)printf("**[while loop] value ='%s' found!\n",while_do_num_s);
       while_m_cmd_max = atoi(while_do_num_s);

       if(while_m_cmd_found==0){
         fflush(fp);
         whereinfileWL3 = ftell(fp);
         if(debug==1)printf("**[while loop] file pointer=%ld\n",whereinfileWL1);
         while_m_cmd_found=1;
       }


    } 


//////////// while count
    if(strstr(stread,"  while count ") !='\0' && strstr(stread,"do") !='\0') {
       x=0;
       if(debug==1)printf("**[while count] while count loop found! \n");
       do{
          while_trash[x]=stread[x];
          x++;
       }while(stread[x] != '1' &&
              stread[x] != '2' &&
              stread[x] != '3' &&
              stread[x] != '4' &&
              stread[x] != '5' &&
              stread[x] != '6' &&
              stread[x] != '7' &&
              stread[x] != '8' &&
              stread[x] != '9');

           if(stread[x-1]==' ') sprintf(while_do_num_s,"%c%c%c",stread[x],stread[x+1],stread[x+2]);;
           if(debug==1)printf("**[while loop] value ='%s' found!\n",while_do_num_s);
           while_c_cmd_max = atoi(while_do_num_s);

       fflush(fp);
       whereinfileWL2 = ftell(fp);
       if(debug==1)printf("**[while loop] file pointer=%ld\n",whereinfileWL2);
       while_c_cmd_found=1;

    } 

///////// end statements

    // end for less than '<' while
    if(strstr(stread," end;")!= '\0' && while_l_cmd_found == 1 && while_l_cmd_sat == 0 && while_l_cmd_typ == 0) {
       if(debug==1)printf("**[END - sub end] end found! for 'while less' \n");
       if(debug==1)printf("**[while] value of var '%s' \n",value_of_variables[y]);
       if(atof(value_of_variables[y]) >= while_l_cmd_max){
             while_l_cmd_sat = 1;
             while_l_cmd_found =0;
       }
       else fseek(fp,whereinfileWL1,0); //tested false do again return to above for
    }

    // end for less than equal '<=' while
    if(strstr(stread," end;")!= '\0' && while_l_cmd_found == 1 && while_l_cmd_sat == 0 && while_l_cmd_typ == 1) {
       if(debug==1)printf("**[END - sub end] end found! for 'while less' \n");
       if(debug==1)printf("**[while] value of var '%s' \n",value_of_variables[y]);
       if(atof(value_of_variables[y]) > while_l_cmd_max){
             while_l_cmd_sat = 1;
             while_l_cmd_found =0;
       }
       else fseek(fp,whereinfileWL1,0); //tested false do again return to above for
    }


   // end for more than '>' while
    if(strstr(stread," end;")!= '\0' && while_m_cmd_found == 1 && while_m_cmd_sat == 0 && while_m_cmd_typ == 0) {
       if(debug==1)printf("**[END - sub end] end found! for 'while more' \n");
       if(debug==1)printf("**[while] value of var '%s' \n",value_of_variables[y]);
       if(atof(value_of_variables[y]) <= while_m_cmd_max){
           while_m_cmd_sat = 1;
           while_m_cmd_found = 0;
       }
       else fseek(fp,whereinfileWL3,0); //tested false do again return to above for
    }

   // end for more than '>=' while
    if(strstr(stread," end;")!= '\0' && while_m_cmd_found == 1 && while_m_cmd_sat == 0 && while_m_cmd_typ == 1) {
       if(debug==1)printf("**[END - sub end] end found! for 'while more' \n");
       if(debug==1)printf("**[while] value of var '%s' \n",value_of_variables[y]);
       if(atof(value_of_variables[y]) < while_m_cmd_max){
           while_m_cmd_sat = 1;
           while_m_cmd_found = 0;
       }
       else fseek(fp,whereinfileWL3,0); //tested false do again return to above for
    }

    if(strstr(stread," end;")!= '\0' && while_c_cmd_found == 1 && while_c_cmd_sat == 0) {
       if(debug==1)printf("**[END - sub end] end found! for 'while count' \n");
       while_c_cmd_times++;
       if(while_c_cmd_times >= while_c_cmd_max){
         while_c_cmd_sat = 1;
         while_c_cmd_found = 0;
       }
       else fseek(fp,whereinfileWL2,0); //tested false do again return to above for
    }

////////////////////end while

    if(strstr(stread,"  if ")!='\0' && 
       strstr(stread," and") =='\0') pascal_if(num_of_space+3,debug); // if/then

    if(strstr(stread,"  until ") !='\0') pascal_until(num_of_space+6,debug);
    if(strstr(stread,"  goto ")  !='\0') pascal_goto(num_of_space+5,debug);

    teststr[0]='\0';
    teststr[1]='\0';

    // check for storing values
    for(loop2=0;loop2<256;loop2++){     // currently only store 256 variables

      teststr[0]='\0';teststr[1]='\0';  // clear memory test strings

      loop4=0;

      //is there a variable stored in this array that could match
      //If we have gotten past main 'begin' and var name bigger or = to one and not constant.
      if(have_begin=='T' && 
         stread[num_of_space]==variable_names[loop2][0] && 
         strlen(variable_names[loop2])>=1 && variable_cons[loop2] != 1){ 

        if (debug==1) printf("**[MAIN] possible variable match found '%c...' at memory location %d:\n",variable_names[loop2][0],loop2);
        for(xxx=1;xxx<=num_of_space;xxx++){strcat(teststr," ");}
        strcat(teststr,variable_names[loop2]);
        if( strncmp(stread,teststr,strlen(teststr))==0 ){ //check to see if a defined variable matches the array

          if (debug==1) printf("**[MAIN] found set match for '%s' \n",variable_names[loop2]);
          loop3=strlen(teststr)+4; //find where to start reading value to set.
          do{
             if(variable_type[loop2]!='s' && 
                strstr(stread," + ")=='\0' &&
                strstr(stread," * ")=='\0' &&
                strstr(stread," / ")=='\0' && 
                strstr(stread," % ")=='\0' &&
                strstr(stread," ^ ")=='\0' &&
                strstr(stread," - ")=='\0'){
					
              if(stread[loop3]!=';') value_of_variables[loop2][loop4]=stread[loop3]; //assign value 
             } 
             if(variable_type[loop2]=='s' && strstr(stread," + ")=='\0'){
              if(stread[loop3]!=';' && stread[loop3]!='\'')value_of_variables[loop2][loop4]=stread[loop3]; //assign value
              if(stread[loop3]=='\'') loop4--; 
             }
             loop3++;
             loop4++;
          }while(stread[loop3-1]!=';'); //read till ';'
          value_of_variables[loop2][loop4-1]='\0';
          value_of_variables[loop2][loop4]='\0';
          if (strstr(stread," + ")!='\0'||
              strstr(stread," - ")!='\0'||
              strstr(stread," * ")!='\0'||
              strstr(stread," / ")!='\0'||
              strstr(stread," ^ ")!='\0'||
              strstr(stread," ~ ")!='\0'||
              strstr(stread," ~;")!='\0'||
              strstr(stread," # ")!='\0'||
              strstr(stread," #;")!='\0'||
              strstr(stread," % ")!='\0' ){                                                              //check to see if there is math
             if(debug==1)printf("**[Main] found math with variable type '%c' \n",variable_type[loop2]);
             if( (variable_type[loop2]=='i') || (variable_type[loop2]=='r')){                            // if variable_type is int or real
				 

				 
               tempi = math_set(stread,debug);
               if(debug==1)printf("**[MAIN] found math set that returned '%f' \n",tempi);
               if(variable_type[loop2]=='r') sprintf(temps,"%12.6f",tempi);
               if(variable_type[loop2]=='i') sprintf(temps,"%12.0f",tempi);  //strip off the decimal of an integer
               wscount=0;                                                //reset 
               while (temps[wscount] == ' ') {
                  wscount++;
               }
  
               // Putting string into another string variable after removing leading white spaces
               for (jloop = wscount, kloop = 0;
                  temps[jloop] != '\0'; jloop++, kloop++) {
                  temps2[kloop] = temps[jloop];
                }
                temps2[kloop] = '\0';
 
               
               strcpy(value_of_variables[loop2],temps2);
               
               if(debug==1)printf("'%s' -> '%s' -> '%s' \n", temps,temps2, value_of_variables[loop2]);
             } 
          }
          if(strstr(stread,"concat(")!='\0' && variable_type[loop2]=='s'){
            if (debug==1) printf("**[MAIN] concat function found. \n");
            strcpy(value_of_variables[loop2],pascal_concat(stread,debug));
          }
          if(strstr(stread," + ")!='\0' && variable_type[loop2]=='s'){
            if (debug==1) printf("**[MAIN] concat_set function found. \n");
            strcpy(value_of_variables[loop2],concat_set(stread,debug));
          }


          if (debug==1){ printf("**[MAIN] Value found and stored: '%s'\n",value_of_variables[loop2]);break;}
        }
      }   
    }
    DoNothing:
    loop++;
    if(loop==9999) break;

  }while(have_end != 'T');
  fclose(fp);

  if (have_program=='F'){
     printf("Pascal Error - 'program' not found or not properly terminated\n");
     printf("  Format: \n");
     printf("  program [ProgramName]; \n");
  }
  if (have_begin=='F') printf("Pascal Error - 'begin' not found \n");
  if (have_end=='F') printf("Pascal Error - 'end.' not found or not properly terminated\n");

  if (debug==1) printf("**[MAIN] Pascal script Terminated\n");
  if (debug==1) printf("**[MAIN] Number of variables: %d\n",number_of_variables);
  fclose(textFilePointer);

return(0);
}

///////////////////////////////////////
////// read
//////////////////////////////////////
void pascal_read(int indent,int debug)
{
  char temptext[50]={'\0'};
  char tempstr[256]={'\0'};
  int loop=0;
  int loop2=0;

  loop=indent;
  do{
    if( stread[loop] != ')' ){
       tempstr[loop2]=stread[loop];
       loop++;
       loop2++;
    }
  }while ( stread[loop] != ')' );                                       // read var name till )

  for(loop=0;loop<256;loop++){
    if( strcmp(tempstr,variable_names[loop])==0) break;
  }

  if(debug==1)printf("**[READ] variable read in '%s' \n",variable_names[loop]);

  scanf("%s",temptext);


  if (debug==1) printf("**[READ] Read value '%s' \n",temptext);
  strcpy(value_of_variables[loop],temptext);
  if (debug==1) printf("**[READ] Read value store '%s' \n",value_of_variables[loop]);

}

////////////////////////////////////////////////////////
////// read_version()
////////////////////////////////////////////////////////
void g_pascal_read_version(int indent)
{
  char tempstr[256];
  int loop=0, loop2=0;

  loop=indent;
  do{
    if( stread[loop] != ')' ){
       tempstr[loop2]=stread[loop];
       loop++;
       loop2++;
    }
  }while ( stread[loop] != ')' );
  tempstr[loop2]='\0';

  for(loop=0;loop<256;loop++){
    if( strcmp(tempstr,variable_names[loop])==0) break;
  }
  strcpy(value_of_variables[loop],version);
}

/////////////////////////////////////////////////////
////// writeln()
/////////////////////////////////////////////////////
void pascal_writeln(int indent, int debug)
{
  //passed in	
  //"int indent" is for - how many characters in should we start reading
  //"int debug" is for - is debugging on? 1=yes	
  int v_loop=0, loop=0, loop2=0, format=0;
  int loop3=0;                                                          //for adding spaces
  int do_again=0;                                                       //do we have more to read in memory -  is there another “,” and parameter being passed
  int format_size=0;                                                    // how many places of buffer charaters + field length 
  int num_of_spaces=0;
  char stringsize[32];
  char tempstr[256], system_string[256];

  if(stread[indent]=='\''){                                             //looking for that "'" to start string read
      loop=indent + 1;
      do{
          if(stread[loop]!='\'' && file_in_use==0 && file_write==0) printf("%c",stread[loop]);
          if(stread[loop]!='\'' && file_in_use==1 && file_write==1) fprintf(textFilePointer,"%c",stread[loop]);

          if(stread[loop]=='\0'){                                       //if we reach NULL before we reach our next "'" or ')'
              printf("Pascal Error - Parse error with writeln\n");      //we have a problem
              break;
          }
          loop++;
      }while(stread[loop-1] != '\'');
        if (stread[loop] == ',') do_again=1;                            //found ',' read in again.
  } 
  //// read in variable name till ')' /////
  else{
      loop=indent;
      do{
          if(stread[loop] != ':' && 
             stread[loop] != ')' && 
             stread[loop] != ','){                                      //checks to see if ok to read  
			                                                //':'=format ',' next string or var ')'end of write/writeln
             tempstr[loop2]=stread[loop];                               //reads in variable name
             loop++;
             loop2++;
          }
      }while(stread[loop] != ':' && 
             stread[loop] != ')' && 
             stread[loop] != ',');                                      //when you find a special character stop
      tempstr[loop2]='\0';                                              //trunk what was read with NULL
      if(debug==1)printf("**[writeln] variable name: '%s'\n",tempstr);  //if debug in on, write the variable that was found


      if (stread[loop] != ')' && stread[loop] != ',' ){                 // if we did not find a ')' or ','
         if (stread[loop] == ':') format=1;                             // so maybe it was ':' did we find ':' ?, if so we need to format 
         if (stread[loop+1] == ',') do_again=1;                         // also check for future ',' a few characters ahead, is so we are not done
         if (stread[loop+2] == ',') do_again=1;
         if (stread[loop+3] == ',') do_again=1;
      }

      if (stread[loop] == ',') do_again=1;                              // if there is a comma, please look at the next

      if(debug==1) printf("**[writeln] let's take a look at what we have so far \n");
      if(debug==1) printf("**[writeln] %s \n",stread);

      if (stread[loop] == ',' && stread[loop+1] == ' ') loop++;         // add an extra forward for the space after comma.      
      loop++;                                                           // forward
      loop2=0;
      if(format==1){                                                    // we decided there is formating.
         do{
           stringsize[loop2]=stread[loop];                              // read the size of the format until ')' and ','
           loop++;
           loop2++;
         }while(stread[loop] != ')' && stread[loop] != ',' );
         format_size=atoi(stringsize);                                  // convert that to an integer - this the number of character needed to display
         if(debug==1)printf("**[writeln] format_size ='%d' \n",format_size);
      }

     //// find variable that matches ////
      for(v_loop=0;v_loop<=256;v_loop++){
          if(strcmp(tempstr,variable_names[v_loop])==0) break; 
      }
      
      if(debug==1) printf("**[writeln] - Var name '%s' \n",tempstr);
      if(debug==1) printf("**[writeln] - Var type '%c' \n",variable_type[v_loop]);
      if(debug==1) printf("**[writeln] - content length '%d'\n",strlen(value_of_variables[v_loop]));

      //variable is string, char, int, real and not file/text
      if(format==0 && variable_type[v_loop] != 't' && file_in_use!=1 ) {
        printf("%s",value_of_variables[v_loop]);
      }

      if(file_in_use==1 && file_write==1 && variable_type[v_loop]!='t'){
        fprintf(textFilePointer,"%s",value_of_variables[v_loop]);
        
        if(debug==1)printf("**[writeln] FILE: attempt to write to file made with \n");
        if(debug==1)printf("**[writeln] FILE: '%s' \n", value_of_variables[v_loop]);
      }
      
      //we don't care about format is the variable is a file. otherwise we do want to calculate
      if(variable_type[v_loop] != 't') num_of_spaces = format_size - strlen(value_of_variables[v_loop]); //the difference between the string length
      if(debug==1 && variable_type[v_loop] != 't')printf("**[writeln] num of spaces needed %d \n",num_of_spaces); 

      if(format==1 && variable_type[v_loop] != 't' && file_in_use!=1){  //format is 1 so we need to apply formatting
		  
          if(format_size >= strlen(value_of_variables[v_loop]) ){
            for(loop3=0;loop3 <= num_of_spaces;loop3++){
              printf(" ");                                              //add padding because we want to format!!
            }
          }
        printf("%s",value_of_variables[v_loop]);                        //print formatted string
        if(debug==1)printf("\n ");
      }
  }
  if(variable_type[v_loop]== 't'){                                      // text file var
     strncpy(open_file,value_of_variables[v_loop],strlen(value_of_variables[v_loop]));
     file_in_use=1;
  }

  if(do_again != 1 && file_write==1 && strstr(stread," writeln")!= '\0') fprintf(textFilePointer,"\n");
  // if(do_again != 1) file_in_use=0;
  if(do_again == 1) pascal_writeln(loop,debug);
}


///////////////////////////////////////////////////////////
////// var
////// this function handles both var and const
///////////////////////////////////////////////////////////
void pascal_var(int debug, int vtype)
{
  int loop;
  int loop3=0;
  char tempchar[1];

  if(vtype==0) block_type=1;
  if(vtype==1) block_type=2;

  if(strncmp(stread,"   ",3)==0)   loop=3;
  if(strstr(stread,"var ") != '\0') loop=4;
  if(strncmp(stread,"    ",4)==0)   loop=4;
  if(strstr(stread," var ") != '\0') loop=5;
  if(strncmp(stread,"     ",5)==0)   loop=5;
  if(strstr(stread,"  var ") != '\0') loop=6;
  if(strstr(stread,"   var ") != '\0') loop=7;
  if(strstr(stread,"    var ") != '\0') loop=8;
  if(strstr(stread,"     var ") != '\0') loop=9;
  if(strstr(stread,"const ") != '\0') loop=6;
  if(strstr(stread," const ") != '\0') loop=7;
  if(strstr(stread,"  const ") != '\0') loop=8;
  if(strstr(stread,"   const ") != '\0') loop=9;

  do{
    if (stread[loop] != ' ') tempchar[0]=stread[loop];
    strncat(variable_names[number_of_variables],tempchar,1);
    loop++;
  }while(stread[loop] != ' ');  //Build var name one char at a time until space

  if(debug==1)printf("**[VAR] Look at allocation: '%s'\n",variable_names[number_of_variables]);

  loop++;

  if( vtype==0 && stread[loop]!=':') printf ("Pascal Error - Expecting ':' with var\n");
  if( vtype==1 && stread[loop]!='=') printf ("Pascal Error - Expecting '=' with var\n");

  if(stread[loop+2]=='s'){  //found string
    variable_type[number_of_variables]='s';
    variable_cons[number_of_variables]=vtype;
     if(debug==1) printf("**[VAR] Found 'string' var. vtype= %d \n",vtype);
  }

  if(stread[loop+2]=='t'){  //found text 
     variable_type[number_of_variables]='t';
     variable_cons[number_of_variables]=vtype;
     if(debug==1) printf("**[VAR] Found 'text' var. vtype= %d : %d \n",vtype,variable_cons[number_of_variables] );
  }

  if(stread[loop+2]=='c'){  //found text 
     variable_type[number_of_variables]='c';
     variable_cons[number_of_variables]=vtype;
     if(debug==1) printf("**[VAR] Found 'char' var. vtype= %d : %d \n",vtype,variable_cons[number_of_variables] );
  }

  if(stread[loop+2]=='i'){  //found integer
     variable_type[number_of_variables]='i';
     variable_cons[number_of_variables]=vtype;
     if(debug==1) printf("**[VAR] Found 'integer' var. vtype= %d : %d \n",vtype,variable_cons[number_of_variables] );
  }

  if(stread[loop+2]=='r'){  //found real
     variable_type[number_of_variables]='r';
     variable_cons[number_of_variables]=vtype;
     if(debug==1) printf("**[VAR] Found 'real' var. vtype= %d : %d \n",vtype,variable_cons[number_of_variables] );
  }

  if(stread[loop+2]=='h'){  //found hex 
     variable_type[number_of_variables]='h';
     variable_cons[number_of_variables]=vtype;
     if(debug==1) printf("**[VAR] Found 'hex' var. vtype= %d : %d \n",vtype,variable_cons[number_of_variables]);
  }

  loop=loop+2; // skip to value

 
  //if constant
  if (vtype==1 && strstr(stread," = ") != '\0'){
    if(debug==1) printf("**[VAR] Marked constant %d and we have an '=' \n",vtype);    
     do{
      value_of_variables[number_of_variables][loop3]=stread[loop];
      loop++;
      loop3++;
    }while(stread[loop]!=';' && stread[loop]!=' ');
    variable_cons[number_of_variables]=vtype;

     if(debug==1)printf("**[VAR] Constant has a set value \n");
  }
  if (variable_cons[number_of_variables]==1 && strstr(stread," = ") == '\0'){
    printf("Pascal Error: Constant value not set \n");
  } 
  variable_names[number_of_variables][loop-5]='\0';

  number_of_variables++;
}

////////////////////////////////////////////////////////
////// label 
///////////////////////////////////////////////////////
void pascal_label(int debug)
{
  int loop=4;
  char tempchar[1];

  block_type=3;
                                                                                                                             
  do{
    if (stread[loop] != ' ') tempchar[0]=stread[loop];
    strncat(label_names[number_of_labels],tempchar,1);
    loop++;
  }while(stread[loop] != ' ');

  if(debug==1)printf("**[label] label name '%s' found \n",label_names);

number_of_labels++; 

}

////////////////////////////////////////////////////////////////////////////////////
////// the pascal 'if' statement
////// if true, read the next line
////// if false, ignore the next line
////// if true with 'begin' and 'end;'
//////   continue to read the next code bits as if begin and end does not exist.
////// if false with 'begin' and 'end;'
//////   send to a subfunction that ignores everything between the 'begin' and 'end;'
///////////////////////////////////////////////////////////////////////////////////////
void pascal_if(int indent, int debug){

int v_loop, loop=0, loop2=0;
char tempstr[256], tempstr2[2];
int operation; //(0->equals)(1->less than)(2->greater than)(3->not equal)(4 -> subset)
int tested_true=0;
int return_value=777;
int int_value1=777;
int int_value2=888;

  loop=indent;
  //// Read in the variable name till space. ///
  do{
      if(stread[loop] != ' ' ){ //checks to see if ok to read
          tempstr[loop2]=stread[loop];                 //reads in variable name
          loop++;
          loop2++;
      }
  }while(stread[loop] != ' ' );
  tempstr[loop2]='\0';
  if(debug==1)printf("**[if] variable name: '%s'\n",tempstr); 
  loop++;
  if (stread[loop] == '=') {
    operation=0;
    loop=loop+2;
  }
  if (stread[loop] == '<' && stread[loop+1] != '>'){
     operation=1;
     loop=loop+2;
  }
  if (stread[loop] == '>'){
     operation =2;
     loop=loop+2;
  }
  if (stread[loop] == '!'){
     operation =3;
     loop=loop+2;
  }
  if (stread[loop] == '<' && stread[loop+1] == '>'){
     operation =3; 
     loop=loop+3;
  }
  if (stread[loop] == '$'){
     operation=4;
     loop=loop+2;
  }
  if(debug==1) printf("**[if] operation = %d\n",operation);

  //// Read in the value name till delimiter ///
  loop2=0;  
 
  //// find variable that matches ////
  for(v_loop=0;v_loop<=256;v_loop++){
     if(strcmp(tempstr,variable_names[v_loop])==0) break;
  }

  if(variable_type[v_loop]=='i' ||variable_type[v_loop]=='r'||variable_type[v_loop]=='h'||variable_type[v_loop]=='t'){
    do{
      if(stread[loop]!=' ') tempstr2[loop2]=stread[loop];
      loop++;
      loop2++;
    }while(stread[loop]!=' ');  
  }

  if(variable_type[v_loop]=='s' ){
    loop++;
    do{
      if(stread[loop]!='\'') tempstr2[loop2]=stread[loop]; 
      loop++;
      loop2++;
    }while(stread[loop]!='\'');  
  }

  tempstr2[loop2]='\0';
  if(debug==1)printf("**[if] value : '%s'\n",tempstr2);


 if(variable_type[v_loop]=='s'){
  if(operation==0){
    return_value=strcmp(value_of_variables[v_loop],tempstr2);
    if(return_value==0) tested_true=1;
  }
  if(operation==1){
    return_value=strcmp(value_of_variables[v_loop],tempstr2);
    if(return_value<0) tested_true=1;
  }
  if(operation==2){
    return_value=strcmp(value_of_variables[v_loop],tempstr2);
    if(return_value>0) tested_true=1;
  }
  if(operation==3){
    return_value=strcmp(value_of_variables[v_loop],tempstr2);
    if(return_value!=0) tested_true=1;
  }
  if(operation==4){
    return_value=strstr(value_of_variables[v_loop],tempstr2);
    if(return_value!='\0') tested_true=1;
  }
 } 

 if(variable_type[v_loop]=='i'){
  int_value1=atoi(tempstr2);
  int_value2=atoi(value_of_variables[v_loop]);
  if(operation==0){
    if(int_value1==int_value2) tested_true=1;
  }
  if(operation==1){
    if(int_value2<int_value1) tested_true=1;
  }
  if(operation==2){
    if(int_value2>int_value1) tested_true=1;
  }
  if(operation==3){
    if(int_value1!=int_value2) tested_true=1;
  }
 }


 if (tested_true==0) pascal_if_subthread(fp); // do nothing if false, 
                                              // but read in the statement
                                              // you will not execute.


}
////////////////////////////////////////////////////////
////if statement sub thread
//// the if ignore function
//// we are not going to perform what we read until we reach 'end;'
//// but only if we found the 'begin'
///////////////////////////////////////////////////////

void pascal_if_subthread()
{


  // if we are in the subrouting, then the if was false
  // and we are reading and ignoring lines

  //read in next line
  fgets(stread,256,fp);
  //if begin is found
  if(strstr(stread, "  begin" ) != '\0'){
    do{
      fgets(stread,256,fp);
    }while(strstr(stread, "  end;" ) == '\0');
  }
  else{
  //just erase the read line with blanks
  //same as do nothing because false
   strcpy(stread,"                 ");
  }
}


//////////////////
////// goto 
//////////////////
void pascal_goto(int indent, int debug)
{

 int loop, loop2=0;
 char temptext[60]={'\0'};


 loop=indent;

 //read until ';'
 do{
   if(stread[loop]!=';'){
     temptext[loop2]=stread[loop];
     //loop2++;
   }
     loop++;
     loop2++;
 }while(stread[loop]!= ';');
 temptext[loop2]='\0';

 if(debug==1)printf("**[goto] '%s' \n", temptext);

 pascal_goto_subthread(temptext);

}

///////////////////////////////////
//////pascal_goto_subthread
//////////////////////////////////
void pascal_goto_subthread(char temptext[60])
{
  int string_length=0;
  int x,match=3;
  char readstring[60];

  do{
    fgets(stread,256,fp);
    if(stread[0]==temptext[0]){                // possible match
      string_length=strlen(stread);
      for(x=0;x<string_length;x++){
         if(stread[x] != ' ' && stread[x] != ':' && stread[x] != '\n' && stread[x]!= '\r' && stread[x]!='\0'){
            readstring[x]=stread[x]; //read in the possible match
         }
         else break;
      }
      if(strncmp(temptext,readstring,x-1)==0){
         match=1;                              //we have a winner!
      } 
    }

  }while(match!=1 && stread[3]!='.');
            
}

/////////////////////////////////////
//////  read_date
/////////////////////////////////////
void g_pascal_read_date(int indent)
{
  char temptext[50];
  char temptext2[50];
  time_t time_now;
  int spot_a, spot_b;
  char tempstr[256];
  int v_loop;
  int loop=0,loop2=0,loop3=0,loop4=0;
  char d_a_f[30];

  loop=indent;
  do{
    if( stread[loop] != ')' && stread[loop] != '['){
       tempstr[loop2]=stread[loop];
       loop++;
       loop2++;
    }
  }while ( stread[loop] != ')' && stread[loop] != '[' );
  tempstr[loop2]='\0';

  for(v_loop=0;v_loop<256;v_loop++){
    if( strcmp(tempstr,variable_names[v_loop])==0) break;
  }

  time(&time_now);
  strcpy(temptext, asctime(localtime(&time_now)));
  strcpy(value_of_variables[v_loop],temptext);

  if (stread[loop] == '['){    // [a .. b]
                               // [a .. bb]
                               // [aa .. bb]
    if(stread[loop+2]==' '){
      sprintf(d_a_f,"%c",stread[loop+1]);
    }
    else{
      sprintf(d_a_f,"%c%c",stread[loop+1],stread[loop+2]);
    }
      spot_a=atoi(d_a_f);
      spot_a--;

    if(stread[loop+2]==' ' && stread[loop+7]==']'){
      sprintf(d_a_f,"%c",stread[loop+6]);
    }
    if(stread[loop+2]==' ' && stread[loop+7]!=']'){
      sprintf(d_a_f,"%c%c",stread[loop+6],stread[loop+7]);
    }
    if(stread[loop+2]!=' ' && stread[loop+7]!=']'){
      sprintf(d_a_f,"%c%c",stread[loop+7],stread[loop+8]);
    }

    spot_b=atoi(d_a_f);
    spot_b--;
    for(loop3=spot_a;loop3<=spot_b;loop3++){
      temptext2[loop4]=temptext[loop3];
      loop4++;
    }
    temptext2[loop4]='\0';
    strcpy(value_of_variables[v_loop],temptext2);
  }
}

////////////////////////////////
////// insert()
////////////////////////////////
void pascal_insert(int indent, int debug){

  int loop=0,loop2=0, v_length=0, v_loop=0;
  int temp_i,int_place=3;
  char char_place[2];
  int temp_loop=0;
  char tempstring[99],insert_string[99], new_string[99];
  char tempstr[99];
  loop=indent;

  //insert('Abe',String,8);insert(value,String,12);

  if(stread[indent]=='\''){
    loop=indent + 1;
    do{
      if(stread[loop]!='\'') insert_string[loop2]=stread[loop];
      if(stread[loop]=='\0'){
        printf("Pascal Error: Parse error with writeln\n");
        break;
      }
      loop++;
      loop2++;
    }while(stread[loop-1] != '\'');
    insert_string[loop2-1]='\0';
    if(debug==1)printf("**[insert] insert string = '%s'\n",insert_string);
  }
  else{
    loop=indent;
    loop2=0;
    do{
      if(stread[loop] != ','){         //checks to see if ok to read
        tempstr[loop2]=stread[loop];   //reads in variable name
        loop++;
        loop2++;
      }
    }while(stread[loop] != ',');
    tempstr[loop2]='\0';
    if(debug==1)printf("**(insert) variable name: '%s'\n",tempstr);

    //// find variable that matches ////
    for(v_loop=0;v_loop<=256;v_loop++){
      if(strcmp(tempstr,variable_names[v_loop])==0) break;
    }
    strcpy(insert_string,value_of_variables[v_loop]);
    temp_i=strlen(insert_string);
    insert_string[temp_i]='\0';
    if(debug==1)printf("**(insert) insert string = '%s'\n",insert_string);
  }

  //// find main string////
  loop++;
  loop2=0;
  do{
    if(stread[loop] != ','){         //checks to see if ok to read
      tempstr[loop2]=stread[loop];   //reads in variable name
      loop++;
      loop2++;
    }
  }while(stread[loop] != ',');
  tempstr[loop2]='\0';
  if(debug==1)printf("**(insert) variable name: '%s'\n",tempstr);

  //// find variable that matches ////
  for(v_loop=0;v_loop<=256;v_loop++){
     if(strcmp(tempstr,variable_names[v_loop])==0) break;
  }

  loop++;

  if(stread[loop+1]==')'){
    char_place[0]=stread[loop];
    int_place=atoi(char_place);
  }
  if(stread[loop+1]!=')'){
    char_place[0]=stread[loop];
    char_place[1]=stread[loop+1];
    int_place=atoi(char_place);
  }

  if(debug==1)printf("**(insert) column insert at %d\n",int_place);
  int_place=int_place - 1;


  v_length=strlen(value_of_variables[v_loop]);
  temp_loop=0;
  do{
    tempstring[temp_loop]=value_of_variables[v_loop][temp_loop + int_place];
    temp_loop++;
  }while(temp_loop <= (v_length - int_place));
  tempstring[temp_loop]='\0';
  if(debug==1)printf("**(insert) string being moved: '%s'\n",tempstring);

  strncpy(new_string,value_of_variables[v_loop],int_place);
  new_string[int_place]='\0';
  strcat(new_string,insert_string);
  strcat(new_string,tempstring);
  strcpy(value_of_variables[v_loop],new_string);


}

//////////////////////////////
////// findrp()
//////////////////////////////
void g_pascal_findrp(int indent, int debug){

  int loop,loop2=0;
  int v_loop;
  char tempstr[99], tempstr2[99], tempstr3[60];
  char * pch;

  loop=indent;

  do{
    if(stread[loop] != ','){         //checks to see if ok to read
      tempstr[loop2]=stread[loop];   //reads in variable name
      loop++;
      loop2++;
    }
  }while(stread[loop] != ',');
  tempstr[loop2]='\0';
  if(debug==1)printf("**(findrp) variable name: '%s'\n",tempstr);

  //// find variable that matches ////
  for(v_loop=0;v_loop<=256;v_loop++){
     if(strcmp(tempstr,variable_names[v_loop])==0) break;
  }

  loop++; // for "'"
  loop++;
  loop2=0;
  do{
    if(stread[loop] != '\'' ){ //checks to see if ok to read
      tempstr2[loop2]=stread[loop];                 //reads in variable name
      loop++;
      loop2++;
    }
  }while(stread[loop] != '\'' );
  tempstr2[loop2]='\0';
  if(debug==1)printf("**(findrp) to be found: '%s'\n",tempstr2);

  loop++; // for ","
  loop++; // for "'"
  loop++;
  loop2=0;
  do{
    if(stread[loop] != '\'' && stread[loop] != ','){ //checks to see if ok to read
      tempstr3[loop2]=stread[loop];                 //reads in variable name
      loop++;
      loop2++;
    }
  }while(stread[loop] != '\'' && stread[loop] != ',');
  tempstr3[loop2]='\0';
  if(debug==1)printf("**[findrp] to replace with: '%s'\n",tempstr3);

  pch = strstr(value_of_variables[v_loop],tempstr2);
  if(pch!='\0') strncpy (pch,tempstr3,strlen(tempstr3));

}
//////////////////////////////
////// findow()
//////////////////////////////
void g_pascal_findow(int indent, int debug){

  int loop,loop2=0;
  int v_loop;
  char tempstr[99], tempstr2[99], tempstr3[60];
  char * pch;

  loop=indent;

  do{
    if(stread[loop] != ','){         //checks to see if ok to read
      tempstr[loop2]=stread[loop];   //reads in variable name
      loop++;
      loop2++;
    }
  }while(stread[loop] != ',');
  tempstr[loop2]='\0';
  if(debug==1)printf("**(findow) variable name: '%s'\n",tempstr);

  //// find variable that matches ////
  for(v_loop=0;v_loop<=256;v_loop++){
     if(strcmp(tempstr,variable_names[v_loop])==0) break;
  }

  loop++; // for "'"
  loop++;
  loop2=0;
 do{
    if(stread[loop] != '\'' ){ //checks to see if ok to read
      tempstr2[loop2]=stread[loop];                 //reads in variable name
      loop++;
      loop2++;
    }
  }while(stread[loop] != '\'' );
  tempstr2[loop2]='\0';
  if(debug==1)printf("**(findow)to be found: '%s'\n",tempstr2);

  loop++; // for ","
  loop++; // for "'"
  loop++;
  loop2=0;

  do{
    if(stread[loop] != '\'' && stread[loop] != ','){ //checks to see if ok to read
      tempstr3[loop2]=stread[loop];                 //reads in variable name
      loop++;
      loop2++;
    }
  }while(stread[loop] != '\'' && stread[loop] != ',');
  tempstr3[loop2]='\0';
  if(debug==1)printf("**[findow] to replace with: '%s'\n",tempstr3);

  pch = strstr(value_of_variables[v_loop],tempstr2);

  if(pch!='\0')strncpy (pch,tempstr3,strlen(tempstr3));

}


/////////////////////////////////////////////////////
////// writecw()
/////////////////////////////////////////////////////
void g_pascal_writewc(int indent, int debug)
{
  int v_loop=0, loop=0, loop2=0, format=0;
  int do_again=0;
  int format_size=0;
  char stringsize[25];
  char tempstr[256];

  if(stread[indent]=='\''){
      loop=indent + 1;
      do{
          if(stread[loop]!='\'' && stread[loop]!=' ' && stread[loop]!='<' && 
             stread[loop]!='>'  && stread[loop]!='&' && stread[loop]!='\"') printf("%c",stread[loop]);

          if(stread[loop]==' ')  echo_wc(1); 
          if(stread[loop]=='<')  echo_wc(2);
          if(stread[loop]=='>')  echo_wc(3);
          if(stread[loop]=='&')  echo_wc(4);
          if(stread[loop]=='\"') echo_wc(5);

          if(stread[loop]=='\0'){
              printf("Pascal Error: Parse error with writeln\n");
              break;
          }
          loop++;
      }while(stread[loop-1] != '\'');
        if (stread[loop] == ',') do_again=1;
  }
  //// read in variable name till ')' /////
  else{
      loop=indent;
      do{
          if(stread[loop] != ':' && stread[loop] != ')' && stread[loop] != ','){ //checks to see if ok to read
              tempstr[loop2]=stread[loop];                 //reads in variable name
              loop++;
              loop2++;
          }
      }while(stread[loop] != ':' && stread[loop] != ')' && stread[loop] != ',');
      tempstr[loop2]='\0';
      if(debug==1)printf("**[writecw] writeln variable name: '%s'\n",tempstr);


      if (stread[loop] != ')' && stread[loop] != ',' ) format=1;
      if (stread[loop] == ',') do_again=1;

      loop++;
      loop2=0;
      if(format==1){
         do{
           stringsize[loop2]=stread[loop];
           loop++;
           loop2++;
         }while(stread[loop] != ')' && stread[loop] != ',' );
         format_size=atoi(stringsize);
      }

     //// find variable that matches ////
      for(v_loop=0;v_loop<=256;v_loop++){
          if(strcmp(tempstr,variable_names[v_loop])==0) break;
      }


      if(format==0) {
        printf("%s",value_of_variables[v_loop]);
      }

      if(format==1){
          if(format_size >> strlen(value_of_variables[v_loop])){
            for(loop2=0;loop2<(format_size - strlen(value_of_variables[v_loop]));loop2++){
              printf(" ");
            }
          }
          printf("%s",value_of_variables[v_loop]);
      }
  }
  if(do_again==1) g_pascal_writewc(loop,debug);
}
//////////////////////////////////////////////////////
// rewrite
// this function is for text file writing prep
// - turns of flag, takes file pointer variable
// - stores filename to be used
//////////////////////////////////////////////////////
void pascal_rewrite(int indent)
{

  char temptext[50];
  char tempstr[256]={'\0'};
  int v_loop,loop=0;
  int loop2=0;

  file_write=1;                                                 // flag to turn on writing to text file.  
  

  loop=indent;
  do{
    if( stread[loop] != ',' ){
       tempstr[loop2]=stread[loop];
       loop++;
       loop2++;
    }
  }while ( stread[loop] != ',' );
  tempstr[loop2]='\0';                                                                                                                             
  for(v_loop=0;v_loop<256;v_loop++){
    if( strcmp(tempstr,variable_names[v_loop])==0) break;       // break at finding matching variable name
  }
  loop=loop+2;
  loop2=0;
   do{                                                          // start reading in next paramater
       if(stread[loop]!='\'') temptext[loop2]=stread[loop];
       if(stread[loop]=='\0'){                                  // we reached null, that should not have happened.
           printf("Pascal Error: Parse error with rewrite\n");
           break;
       }
       loop++;
       loop2++;
   }while(stread[loop-1] != '\'');
  temptext[loop2-1]='\0';
  strcpy(value_of_variables[v_loop],temptext);                  // store value into variable
  
  //open are create the name of the file that was specified
  textFilePointer= fopen(temptext,"a");

}

/////////////////////////////////////////////
////// until 
////////////////////////////////////////////
void pascal_until(int indent, int debug){

int v_loop, loop=0, loop2=0;
int x=0; //second loop
int number_found=0;  //check to see if we need to search for right side variable
char tempstr[256], tempstr2[3];
int operation;       //(0->equals)(1->less than)(2->greater than)(3->not equal)(4 -> subset)
int tested_true=0;
int return_value=777;
int int_value1=777;
int int_value2=888;

  if(repeat_cmd_found != 1){
    printf("Pascal Error: Need 'repeat' command for 'until' command \n");
    exit(0);
  }

  loop=indent;
  //// Read in the variable name till space. ///
  do{
      if(stread[loop] != ' ' ){ //checks to see if ok to read
          tempstr[loop2]=stread[loop];                 //reads in variable name
          loop++;
          loop2++;
      }
  }while(stread[loop] != ' ' );
  tempstr[loop2]='\0';
  if(debug==1)printf("**[until] variable name: '%s'\n",tempstr);


  loop++;  // add one for space

  if (stread[loop] == '=') {
    operation=0;
    loop=loop+2;
  }
  if (stread[loop] == '<' && stread[loop+1] != '>'){
     operation=1;
     loop=loop+2;
  }
  if (stread[loop] == '>'){
     operation =2;
     loop=loop+2;
  }
  if (stread[loop] == '!'){
     operation =3;
     loop=loop+2;
  }
  if (stread[loop] == '<' && stread[loop+1] == '>'){
     operation =3;
     loop=loop+3;
  }
  if (stread[loop] == '$'){
     operation=4;
     loop=loop+2;
  }

  if(debug==1) printf("**[until] operation = '%d'\n",operation);

  //// Read in the value name till delimiter ///
  loop2=0;

  //// find variable that matches ////
  //// 0 = true  \0 (null is false) once true break at v_loop value
  for(v_loop=0;v_loop<=256;v_loop++){
     if(strcmp(tempstr,variable_names[v_loop])==0) break;
  }
  
  if(debug==1) printf("**[until] found var=%s->%s\n",variable_names[v_loop],value_of_variables[v_loop]);


/// read standard value as anything but char or string  
if(variable_type[v_loop]=='i' ||variable_type[v_loop]=='r'||variable_type[v_loop]=='h'||variable_type[v_loop]=='t'){
    do{
      if(stread[loop]!=' ' && stread[loop]!=';') tempstr2[loop2]=stread[loop];
      loop++;
      loop2++;
    }while(stread[loop]!=' ' && stread[loop]!=';');
    if(tempstr2[0]!='1' 
    && tempstr2[0]!='2' 
    && tempstr2[0]!='3' 
    && tempstr2[0]!='4' 
    && tempstr2[0]!='5' 
    && tempstr2[0]!='6'
    && tempstr2[0]!='7' 
    && tempstr2[0]!='8'
    && tempstr2[0]!='9') number_found=1; // found right side number
    
  }

/// read standard value as a string
  if(variable_type[v_loop]=='s' ){
    loop++;
    do{
      if(stread[loop]!='\'') tempstr2[loop2]=stread[loop];
      loop++;
      loop2++;
    }while(stread[loop]!='\'');
  }

  /// the comapairson value has not been stored to tempstr2
  /// check here to see of next in tempstr2 variable and not a value
  /// treebee
   if(variable_type[v_loop] == 'i' || variable_type[v_loop] == 'r' && number_found == 0){
    //extract variables values
    for(x=0;x<=256;x++){
      if (strstr(tempstr2,variable_names[x])!='\0' && strlen(variable_names[x])>=1){
          if(debug==1)  printf("**[until] found variable NAME '%s' \n",variable_names[x]); 
          strcpy(tempstr2,"                   ");
          strcpy(tempstr2,value_of_variables[x]);
          if(debug==1)  printf("****[untill] found variable value '%s' \n",tempstr2);
     }
    }
  } // if number_found=0;

  ///
  tempstr2[loop2]='\0';
  if(debug==1)printf("**[until] value : '%s'\n",tempstr2);
 if(variable_type[v_loop]=='s'){
  if(operation==0){
    return_value=strcmp(value_of_variables[v_loop],tempstr2);
    if(return_value==0) tested_true=1;
  }
  if(operation==1){
    return_value=strcmp(value_of_variables[v_loop],tempstr2);
    if(return_value<<0) tested_true=1;
  }
  if(operation==2){
    return_value=strcmp(value_of_variables[v_loop],tempstr2);
    if(return_value>>0) tested_true=1;
  }
  if(operation==3){
    return_value=strcmp(value_of_variables[v_loop],tempstr2);
    if(return_value!=0) tested_true=1;
  }
  if(operation==4){
    return_value=strstr(value_of_variables[v_loop],tempstr2);
    if(return_value!='\0') tested_true=1;
  }
 }

 if(variable_type[v_loop]=='i'){
  int_value1=atoi(tempstr2);
  int_value2=atoi(value_of_variables[v_loop]);
  if(operation==0){
    if(int_value1==int_value2) tested_true=1;
    if(debug==1)printf("**[until] Is '%d' = '%d' \n",int_value1,int_value2);
  }
  if(operation==1){
    if(int_value2<int_value1) tested_true=1;
    if(debug==1)printf("**[until] Is '%d' < '%d' \n",int_value2,int_value1);
  }
  if(operation==2){
    if(int_value2>int_value1) tested_true=1;
    if(debug==1)printf("**[until] Is '%d' > '%d' \n",int_value2,int_value1);
  }
  if(operation==3){
    if(int_value1!=int_value2) tested_true=1;
    if(debug==1)printf("**[until] Is '%d' ! '%d' \n",int_value1,int_value2);
  }
 }

 if (tested_true==1 && debug==1) printf("**[until] Tested True!\n");
 if (tested_true==0 && debug==1) printf("**[until] Tested False!\n");
 if (tested_true==0) fseek(fp,whereinfile,0); //tested false do again 
}

/////////////////////////////
/// wround
/// write round number
//////////////////////////////
int pascal_wround (int indent, int debug)
{

  float float_num;

  int loop=0, loop2=0;
  char tempstr[256];
  int int_num;

  loop=indent;
  do{
      if( stread[loop] != ')' ){           //checks to see if ok to read
          tempstr[loop2]=stread[loop];     //reads in content
          loop++;
          loop2++;
      }
  }while( stread[loop] != ')' );
  tempstr[loop2]='\0';                      //terminate string

  float_num = atof(tempstr);


  int_num = (int)(float_num < 0 ? (float_num - 0.5) : (float_num + 0.5));
  printf("%d\n", int_num);
  return int_num;

}


///////////////////////////////////////////////////////////
////// math_set()
///////////////////////////////////////////////////////////
float math_set(char *command,int debug )
{
  int loop=0;
  int loop2=0;
  int loop3=0;
  int x;
  int numofints=0;                         // number of numbers(not ints now)
  char char_value[25][25]={'\0'};          // up to 15 values that are 15 long
  float i_return;                          // was int i_return;
  float value[5]={0};                      // was int value[5]={0}; 
  char operation[11];                      // up to 10 operations
  int numofops=0;
  char tempname[25];

  if(debug==1) printf("**[Math_set] Enter module \n");

   if(strstr(command,";") == '\0') {
     printf("Pascal Error: parse error: %s \n",command);
     exit(0); 
   }
  strncpy(operation,"     \0",6);

  do{                                            //foward string place till we get to '=' ; that is were the values are.
    loop++;
  }while(command[loop] != '=');                  //end do while #1
 
  loop++;                                        // add one more for space
  //loop++;
  //Nothing is done with what was read before the '= '


  do{
    do{
      char_value[loop2][loop3]=command[loop];    // loop2 is the number of value read
      //if(debug==1)  printf("****[math_set] iiii found variable value '%s' \n",char_value[loop2]);
      loop++;                                    // loop increase overall place
      loop3++;                                   // loop 3 increase since = and reads after
    }while(command[loop]!='+'                
         &&command[loop]!='-'
         &&command[loop]!='*'
         &&command[loop]!='^'
         &&command[loop]!='/'
         &&command[loop]!='%'
         &&command[loop]!='#'
         &&command[loop]!='~'
         &&command[loop]!=';');                  // use an operator as a place for end of variable or number

         
    //char_value[loop2][loop3+1]='\0';               // terminiate that value with NULL
    if(debug==1)  printf("****[math_set] found variable value '%s' \n",char_value[loop2]);


    //extract variables values
    for(x=0;x<=256;x++){
      if (strstr(char_value[loop2],variable_names[x])!='\0' && strlen(variable_names[x])>=1){
          if(debug==1)  printf("**[math_set] found variable NAME '%s' \n",char_value[loop2]); 
          strcpy(char_value[loop2],"                   ");
          strcpy(char_value[loop2],value_of_variables[x]);
          if(debug==1)  printf("****[math_set] found variable value '%s' \n",char_value[loop2]);
     }
    }

    if(command[loop]=='+'){
       operation[numofops]='+';
       numofops++;
       loop++;
    }

    if(command[loop]=='-'){
       operation[numofops]='-';
       numofops++;
       loop++;
    }

    if(command[loop]=='/'){
       operation[numofops]='/';
       numofops++;
       loop++;
    }

    if(command[loop]=='*'){
       operation[numofops]='*';
       numofops++;
       loop++;
    }


    if(command[loop]=='^'){
       operation[numofops]='^';
       numofops++;
       loop++;
    }


    if(command[loop]=='~'){
       operation[numofops]='~';
       numofops++;
       loop++;
    }

    if(command[loop]=='%'){
       operation[numofops]='%';
       numofops++;
       loop++;
    }

    if(command[loop]=='#'){
       operation[numofops]='#';
       numofops++;
       loop++;
    }


    value[numofints]=999;
    value[numofints]=atof(char_value[loop2]);
    if(debug==1) printf("**[math set] FINAL format value to '%lf' \n",value[numofints]);

    loop2++;
    loop3=0;

    numofints++;

  }while(command[loop] !=';');


  if(debug==1)printf("**[math_set] value #0 = '%f' operation #0 = '%c' value #1 = '%f' \n",value[0],operation[0],value[1]); 

  if (operation[0]=='+'){
     i_return = value[0] + value[1];                                                  //Addition
     if(debug==1)printf("**[math set] (EQU) %fl + %fl = %fl\n",value[0],value[1],i_return);
  }

  if (operation[0]=='-') i_return = value[0] - value[1];                              //Subtraction
  if (operation[0]=='*'){
     i_return = value[0] * value[1];                                                  //multiplication
     if(debug==1)printf("**[math set] (EQU) %fl * %fl = %fl\n",value[0],value[1],i_return);
  }
  if (operation[0]=='/') i_return = value[0] / value[1];                              //division
  if (operation[0]=='%') i_return = (int)value[0]%(int)value[1];                      //modulas
  if (operation[0]=='^') i_return = pow(value[0],value[1]);                           //power
  if (operation[0]=='#') i_return = sqrt(value[0]);                                   //square root
  if (operation[0]=='~') i_return = (int)(value[0] < 0 ? (value[0] - 0.5) : (value[0] + 0.5));

  if(debug==1)printf("**[math_set] sub value = '%f' \n",i_return);

  if(numofops == 1)   return(i_return);


  if (operation[1]!=' '){
    if (operation[1]=='+') i_return = i_return + value[2];
    if (operation[1]=='-') i_return = i_return - value[2];
    if (operation[1]=='*') i_return = i_return * value[2];
    if (operation[1]=='/') i_return = i_return / value[2];
    if (operation[1]=='^') i_return = pow(i_return,value[2]);
    
    if(debug==1)printf("**[math_set] operation #1 = '%c' value #2 = '%f' \n",operation[1],value[2]);
    if(debug==1)printf("**[math_set] sub value = '%f' \n",i_return);
  }

  if (operation[2]!=' '){
    if (operation[2]=='+') i_return = i_return + value[3];
    if (operation[2]=='-') i_return = i_return - value[3];
    if (operation[2]=='*') i_return = i_return * value[3];
    if (operation[2]=='/') i_return = i_return / value[3];
    if (operation[2]=='^') i_return = pow(i_return,value[3]);
    if(debug==1)printf("**[math_set] operation #2 = '%c' value #3 = '%f' \n",operation[2],value[3]);  
    if(debug==1)printf("**[math_set] sub value = '%f' \n",i_return);                                                                                                                          
  }

  if (operation[3]!=' '){
    if (operation[3]=='+') i_return = i_return + value[4];
    if (operation[3]=='-') i_return = i_return - value[4];
    if (operation[3]=='*') i_return = i_return * value[4];
    if (operation[3]=='/') i_return = i_return / value[4];
    if (operation[3]=='^') i_return = pow(i_return,value[4]);
    if(debug==1)printf("**[math_set] operation #3 = '%c' value #4 = '%f' \n",operation[3],value[4]);  
    if(debug==1)printf("**[math_set] sub value = '%f' \n",i_return);  
  }

  if (operation[4]!=' '){
    if (operation[4]=='+') i_return = i_return + value[5];
    if (operation[4]=='-') i_return = i_return - value[5];
    if (operation[4]=='*') i_return = i_return * value[5];
    if (operation[4]=='/') i_return = i_return / value[5];
    if (operation[4]=='^') i_return = pow(i_return,value[5]);
    if(debug==1)printf("**[math_set] operation #4 = '%c' value #5 = '%f' \n",operation[4],value[5]);  
    if(debug==1)printf("**[math_set] sub value = '%f' \n",i_return);  
  }


  if (operation[5]!=' '){
    if (operation[5]=='+') i_return = i_return + value[6];
    if (operation[5]=='-') i_return = i_return - value[6];
    if (operation[5]=='*') i_return = i_return * value[6];
    if (operation[5]=='/') i_return = i_return / value[6];
    if (operation[5]=='^') i_return = pow(i_return,value[6]);
    if(debug==1)printf("**[math_set] operation #5 = '%c' value #6 = '%f' \n",operation[5],value[6]);  
    if(debug==1)printf("**[math_set] sub value = '%f' \n",i_return);  
  }

  if (operation[6]!=' '){
    if (operation[6]=='+') i_return = i_return + value[7];
    if (operation[6]=='-') i_return = i_return - value[7];
    if (operation[6]=='*') i_return = i_return * value[7];
    if (operation[6]=='/') i_return = i_return / value[7];
    if (operation[6]=='^') i_return = pow(i_return,value[7]);
    if(debug==1)printf("**[math_set] operation #6 = '%c' value #7 = '%f' \n",operation[6],value[7]);  
    if(debug==1)printf("**[math_set] sub value = '%f' \n",i_return);  
  }


  if (operation[7]!=' '){
    if (operation[7]=='+') i_return = i_return + value[8];
    if (operation[7]=='-') i_return = i_return - value[8];
    if (operation[7]=='*') i_return = i_return * value[8];
    if (operation[7]=='/') i_return = i_return / value[8];
    if (operation[7]=='^') i_return = pow(i_return,value[8]);
    if(debug==1)printf("**[math_set] operation #7 = '%c' value #8 = '%f' \n",operation[7],value[8]);  
    if(debug==1)printf("**[math_set] sub value = '%f' \n",i_return);  
  }

  return(i_return);

}



///////////////////////////////////
/// sqrt write square root
/// return square root of number
//////////////////////////////////
float pascal_wsqrt (int indent, int debug)
{

  float float_num;
  float sqrt_float_num;

  int loop=0, loop2=0;
  char tempstr[256];

  loop=indent;
  do{
      if( stread[loop] != ')' ){           //checks to see if ok to read
          tempstr[loop2]=stread[loop];     //reads in content
          loop++;
          loop2++;
      }
  }while( stread[loop] != ')' );
  tempstr[loop2]='\0';                      //terminate string

  float_num = atof(tempstr);

  sqrt_float_num=sqrt(float_num);
  
  printf("%f\n", sqrt_float_num);
  return sqrt_float_num;

}


/////////////////////////////////////////////////////////////
////// delete()
////////////////////////////////////////////////////////////
void pascal_delete(char *stread,int indent, int debug){

 int loop, loop2, v_loop, temp_loop,int_place, int_count;
 char tempstr[99]={'\0'};
 char tempstring[99]={'\0'};
 char delete_string[99];
 char char_place[2], char_count[2];
 char new_string[99];
 loop=indent;
 loop2=0;

 
 do{
   if(stread[loop] != ','){         //checks to see if ok to read (comma seperated values)
     tempstr[loop2]=stread[loop];   //reads in variable name
     loop++;
     loop2++;
   }
 }while(stread[loop] != ',');
 tempstr[loop2]='\0';
 if(debug==1)printf("**(delete) variable name: '%s'\n",tempstr);

 //// find variable that matches ////
 //// store name in tempstr      ////
 for(v_loop=0;v_loop<=256;v_loop++){
   if(strcmp(tempstr,variable_names[v_loop])==0) break;
 }

 if(debug==1)printf("**(delete) variable memory place is %d \n",v_loop);
 if(v_loop >= 250) printf ("Pascal Error: Variable not found for delete function! \n");
 
 loop++;

 if(stread[loop+1]==','){
   char_place[0]=stread[loop];
   int_place=atoi(char_place);
   loop=loop+2;
 }
 else{
    char_place[0]=stread[loop];
    char_place[1]=stread[loop+1];
    int_place=atoi(char_place);
    loop=loop+3;
  }

  if(debug==1)printf("**(delete) column start delete at %d\n",int_place);
  int_place=int_place - 1;

  if(stread[loop+1]==')'){
    char_count[0]=stread[loop];
    char_count[1]='\0';
    int_count=atoi(char_count);
  }
  if(stread[loop+1]!=')'){
    char_count[0]=stread[loop];
    char_count[1]=stread[loop+1];
    char_count[2]='\0';
    int_count=atoi(char_count);
  }
  if(debug==1)printf("**(delete) count '%s' = '%d'\n",char_count,int_count);

  temp_loop=0;
  do{
    tempstring[temp_loop]=value_of_variables[v_loop][temp_loop + int_place + int_count];
    temp_loop++;
  }while(value_of_variables[v_loop][temp_loop + int_place + int_count]!='\0');

  tempstring[temp_loop]='\0';
  if(debug==1)printf("**(delete) string being moved: '%s'\n",tempstring);

  strncpy(new_string,value_of_variables[v_loop],int_place);
  new_string[int_place]='\0';
  strcat(new_string,tempstring);
  strcpy(value_of_variables[v_loop],new_string);

}


///////////////////////////
// pascal for 1
//////////////////////////

void pascal_for(int indent, int debug){


}

////////////////////////////
//// CloseFile
///////////////////////////
void g_pascal_closefile()
{

  file_in_use=0;
  file_write=0;

  file_read=0;

  fclose(textFilePointer);

}




