///////////////////////////////////////////////////////////
////// GibPascal pascal_string.c
////// Released under the GPLv3
////// Written by:
//////    Michael Gibson
//////    (c)2003-2021
///////////////////////////////////////////////////////////

#include <string.h>
#include <stdio.h>

char variable_names_string[256][256];
char variable_type_string[256];
char value_of_variables_string[256][256];


////////////////////////////////////////////////////////////////////
////// concat()
/////////////////////////////////////////////////////////////////
char *pascal_concat(char *command,int debug)
{
  int loop=0;
  int loop2=0;
  int loop3=0;
  char tempstr[255];
  char value_n[255];
  char value_a[120],t_value_a[120];
  char value_b[120],t_value_b[120];
  do{
    loop++;
  }while(command[loop] != '(');
  if(command[loop+1]=='\''){
    loop=loop+2;
    do{
      if(command[loop]!='\'') value_a[loop2]=command[loop];
      if(command[loop]=='\0'){
          printf("Pascal Error - Parse error with concat\n");
          break;
      }
      loop++;
      loop2++;
    }while(command[loop] != '\'');
    value_a[loop2]='\0';
    loop++;
  }
  else{
    loop++;
    do{
      if( command[loop] != ',' ){
       tempstr[loop2]=command[loop];
       loop++;
       loop2++;
      }
    }while ( command[loop] != ',' );
    tempstr[loop2]='\0';
    for(loop3=0;loop3<256;loop3++){
      if( strcmp(tempstr,variable_names_string[loop3])==0) break;
    }
    strcpy(value_a,value_of_variables_string[loop3]);
    if(debug==1)printf("**[concat]tempstr ='%s'\n",tempstr);
  }
  if(debug==1)printf("**[concat]value of value_a = '%s'\n",value_a);
  loop2=0;
  if(debug==1)printf("**[concat]value of check command[loop]='%c'\n",command[loop]);
  if(command[loop+1]=='\''){
    loop=loop+2;
    do{
      if(command[loop]!='\'') value_b[loop2]=command[loop];
      if(command[loop]=='\0'){
          printf("Pascal Error - Parse error with concat\n");
          break;
      }
      loop++;
      loop2++;
    }while(command[loop] != '\'');
    value_b[loop2]='\0';
  }
  else{
    loop++;
    do{
      if( command[loop] != ')' ){
       tempstr[loop2]=command[loop];
       loop++;
       loop2++;
      }
    }while ( command[loop] != ')' );
    tempstr[loop2]='\0';
    for(loop3=0;loop3<256;loop3++){
      if( strcmp(tempstr,variable_names_string[loop3])==0) break;
    }
    if(debug==1)printf("**[concat]tempstr ='%s'\n",tempstr);
    strcpy(value_b,value_of_variables_string[loop3]);
  }
  if(debug==1)printf("**[concat]value of value_b = '%s'\n",value_b);
  strcpy(value_n,value_a);
  strcat(value_n,value_b);
}

///////////////////////////////////////////////////////////
////// concat_set()
///////////////////////////////////////////////////////////
char *concat_set(char *command, int debug)
{
  int loop=0;
  int loop2=0;
  int loop3=0;
  int x;
  int numofchars=0;
 
  char value[255][255];
  char set_value[255][255];
  char c_return;
  char newvalue[255];

  char operation[19];
  int numofops=0;

  strncpy(operation,"                 \0",18);

  do{
    loop++;
  }while(command[loop] != '=');
  loop++;

  do{
    if(command[loop+1]!='\''){
      do{
        value[loop2][loop3]=command[loop];
     
        loop++;
        loop3++;
      }while(command[loop]!='+' && command[loop]!=';');
      value[loop2][loop3]='\0';

      for(x=0;x<=256;x++){
        if (strstr(value[loop2],variable_names_string[x])!='\0' && strlen(variable_names_string[x])>=1){
            strcpy(set_value[loop2],value_of_variables_string[x]);
            if(debug==1)printf("**[Concat_Set]var '%s' found.\n",value[loop2]);
            if(debug==1)printf("**[concat_set]value set from variable '%s'\n",set_value[loop2]);

        }
      } //end for
    }
    else{
      loop=loop+2;
      do{
        if(command[loop]!='\'') value[loop2][loop3]=command[loop];
        loop++;
        loop3++;
      }while(command[loop]!='\'' && command[loop]!=';');
      value[loop2][loop3]='\0';
      strcpy(set_value[loop2],value[loop2]);
      if(debug==1)printf("**[concat_set]value set from quote '%s'\n",set_value[loop2]);
    }


    if(command[loop]=='+'){
       operation[numofops]='+';
       numofops++;
       loop++;
    }

    loop2++;
    loop3=0;

    numofchars++;
  }while(command[loop] !=';');

 for(x=0;x<=256;x++){
    if(set_value[x][1]!='\0')strcat(newvalue,set_value[x]);
 }

 strcat(newvalue,"\0");

}

